package lucastest;

import java.util.ArrayList;


/**
 * Does the main work of finding probabilities for a coalescence in its constructor
 */
public class ProbabilitiesForACoalescence {
    SpeciesSet speciesSet;
    GTree gTree;
    int n;
    ProbabilitiesForCoalescers coalescerPrs;
    ProbabilitiesForPersister persisterPrs[];


    ProbabilitiesForACoalescence(SpeciesSet speciesSet, GTree gTree, int n)  {
        this.speciesSet = speciesSet;
        this.gTree = gTree;
        this.n = n;
        coalescerPrs = new ProbabilitiesForCoalescers(speciesSet, gTree, n);
        findPersistersProbabilities();
    }


    public String asText() {
        StringBuffer buffer = new StringBuffer();
        buffer.append(coalescerPrs.asText());
        for (int k = 0; k < persisterPrs.length; k++) {
            buffer.append(String.format("persister lineage %d\n", n));
            buffer.append(persisterPrs[k].asText());
        }
        return buffer.toString();
    }

    private void findPersistersProbabilities() {
        GNode node = gTree.getNode(n);
        int i = node.getChX();
        int j = node.getChY();
        Lineage iLin = new Lineage(gTree, i);
        Lineage jLin = new Lineage(gTree, j);
        ArrayList<Integer> persisterLins = gTree.collectPersistersAtCoal(i, j, iLin.endT);
        persisterPrs = new ProbabilitiesForPersister[persisterLins.size()];
        for (int kk = 0; kk < persisterLins.size(); kk++) {
            int k = persisterLins.get(kk);
            Lineage kLin = new Lineage(gTree, k);
            persisterPrs[kk] = new ProbabilitiesForPersister(speciesSet, coalescerPrs, iLin, jLin, kLin);
        }

    }




}
