package lucastest;

/**
 * A fixed set of 2 or 3 species (which don't merge), constructed from config
 */
public class SpeciesSet {

    private final double mRate;

    private final double [] cRates;
    private int nTips;

    public SpeciesSet(Config config) {
        this.nTips = config.nSpeciesTips;
        this.mRate = config.mRate;
        cRates = new double[nTips];
        for (int b = 0; b < nTips; b++) {
            cRates[b] = config.cRates.get(b);
        }
    }


    int getNTips() {
        return nTips;
    }


    public double getMRate() {
        return mRate;
    }


    public double getCRate(int n) {
        return cRates[n];
    }


    public double getMeanCRate() {
        double mcr = 0.0;
        for (int b = 0; b < cRates.length; b++) {
            mcr += cRates[b];
        }
        return mcr / nTips;
    }

}
